//------------------------------------------------------------------------------ 
//       :
// -     2 .
//
// -       RW, RS, E   .
// -       V1[]        
//    0,   7812,5   .=128 .
// -       :
//                 7   6    5    4   3   2   1   0
//                [T] [RW] [RS] [E] [7] [6] [5] [4]
//   > T -    ,   7 (+0 ) -       
//   > RW - 1-, 0- ( 0),         .
//   > RS - 0- , 1-  (.    )
//   > E -    (1- )
//   > [7] [6] [5] [4] -      ( ,   -  )
//
// -    -   8      
//    HD44780,           
//        (     )  
//     
//        204 V2[85].         
//         .
// -            V2[]=>V1[]
//      ()     .
//        6  :      ,  ,
//    ,   ,  ,  .     ,
//   ..    16           ,
//      .
//
// -            
//     ( 2   ).
//
//             , 
//         -    
//   .      .
//------------------------------------------------------------------------------ 
//------------------------------------------------------------------------------ 
//    ANSI      AnsiToLcd
// Ansi     0xC0  0xFF, ..     : __=ChToLcd[y-0xc0];
//     ,       ,     
//  ,        .
//
// fv.e=1    
//       
FBYTE ChToLcd[64]={
// "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4,0xA5,0xA6,0x4B,0xA7,0x4D,0x48,0x4F,0xA8,
// "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB,0xAC,0xE2,0xAD,0xAE,0xC4,0xAF,0xB0,0xB1,
// "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE,
// "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""
0x70,0x63,0xBF,0x79,0xE4,0x78,0xE5,0xC0,0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7 };
//------------------------------------------------------------------------------ 
//       
#define BLINK_ON     0x0d        //  -  
#define LINE_ON      0x0e        //  -  
#define CUR_OFF      0x0c        //  

#define LCD_H        4
#define LCD_W        20

volatile BYTE V1[8];             //    
volatile BYTE iV1=0;             //      
volatile BYTE nV1=0;             //     
volatile BYTE wV1=0;             //        

//  ""       .
BYTE V2[85]={0x30, 0x30, 0x30, 0x20, 0x28, 0x06, 0x0e, 0x01, 'Z', 'U', ' ', 'v', '2', '.', '0', '.', '0', '0'};
volatile BYTE iV2=0;             //    
volatile BYTE nV2=18;            //     
volatile BYTE aV2;               //   
volatile BYTE lV2;               //          :
//                 
// ,           
volatile BYTE fc=0xff;
// fc=255    -    CUR_OFF
// b76543210
//           - 7=1    BLINK_ON
//           - 7=0    LINE_ON
//           - 1  0      
//           - 6...2      
volatile BYTE t_2;

volatile struct VideoControl
  {
  BYTE                      // ,     
  s1:1,                     //    0  ()
  s2:1,                     //    1       
  s3:1,                     //    2       
  s4:1,                     //    3  ()
  d:1,                      //         0-, 1-
  t:1,                      // 0 -           
                            // 1 -     
  h:1,                      // 0 -      (   )
                            // 1 -      (    )
  e:1;                      // 0 -      ( )
                            // 1 -  ANSI      LCD 
                            // (     ) 
                            //        (  )
  }fv;
  
volatile BYTE nSh=0;        //     
volatile BYTE pSh=255;      //   1/10     (255 -  )
volatile BYTE cSh=255;      //    -    10   
                            //  cSh=0      cSh=pSh
volatile BYTE xSh;          //      

//           5/10  
#define SH5(n) {nSh=n; pSh=5; cSh=2;}
//       1    
#define SH(n) {nSh=n; pSh=255; cSh=2;}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// 
//        FLASH
FCHAR _t0[]="  ";
FCHAR _t1[]=" ";
FCHAR _t2[]="";
FCHAR _t3[]=" ";
FCHAR _t4[]=" ,";
FCHAR _t5[]="  ,";
FCHAR _t6[]=" ,";
FCHAR _t7[]=" ,";
FCHAR _t8[]=" ,";
FCHAR _t9[]=" ...";
FCHAR _t10[]="--------------------";
FCHAR _t11[]="          ..";
FCHAR _t12[]="=";
FCHAR _t13[]="=";
FCHAR _t14[]="()=";
FCHAR _t15[]=" =";
FCHAR _t16[]="I(A)=";
FCHAR _t17[]="V()=";
FCHAR _t18[]="V()=";

//------------------------------------------------------------------------------ 
//            
//    FLASH.
PGM_P PROGMEM Wr[]={_t0, _t1, _t2, _t3, _t4, _t5, _t6, _t7, _t8, _t9, _t10, _t11, _t12, _t13, _t14, _t15, _t16, _t17, _t18};
//------------------------------------------------------------------------------ 
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// 
//    FLASH.
//     
// 0-79 -           0-19( )20-29()...
// 100  I           I [] ( )
// 101  I           I [] ( ,  , )
// 102  I           I [] (   )
// 103  I           I [] (  )
// 110  I         I [.] (     )
// 111  I         I [.] (     )
// 112  I         I [.] ( )
// 113  I         I [.x] ( )
// 120  I          I [::]
// 130  N         Nconst
// 140  P, N          P+Nconst
// 
//  1
FCHAR _s0[]={
            0, 140, 1, 0, 
            20, 140, 1, 1, 
            40, 140, 1, 2, 
            60, 140, 1, 3, 
            255
            };
//  2
FCHAR _s1[]={
            0, 130, 12, 100, 0, 10, 130, 18, 113, 2,
            20, 130, 13, 101, 0, 30, 130, 17, 112, 2,
			40, 130, 14, 102, 0, 52, 130, 16, 111, 2,
			60, 130, 15, 103, 0, 72, 120, 0, 
            255
            };
//           .
//    FLASH.
PGM_P PROGMEM Sh[]={_s0, _s1};
//------------------------------------------------------------------------------ 
