
//******************************************************************************
//     
//******************************************************************************

//------------------------------------------------------------------------------ 
//  SRAM  size  c
void StrF(BYTE *tg, BYTE c, BYTE size)
{
while(size--){tg[size]=c;}
}
//------------------------------------------------------------------------------ 
//  sr(SRAM)  tg(SRAM)  size
void memcpyR(BYTE *tg, const BYTE *sr, BYTE size)
{
while(size--){tg[size]=sr[size];}
}
//------------------------------------------------------------------------------ 
//   Wr(FLASH)  V2(SRAM)
void ToV2(BYTE t)
{
PGM_P sr=(PGM_P)(FRW(&(Wr[t])));            //      FLASH
char c;                                     // 
while(true)
  {
  c=FRB(sr++);                              //  
  if(!c)return;                             //  0  
  V2[xSh++]=c;                              //   V2
  }
}
//------------------------------------------------------------------------------
//        
// a -    
// t -  
// m -  (2- , 10-, 16-)
void PrnInt(long a, BYTE t, BYTE m)
{
BYTE *y=(BYTE*)(WORD(V2)+(xSh+=t-1));//     
xSh++;								//       
do{                             	//      
  *y=(a%m)+'0';                 	//  
  if(*y>'9')(*y)+=7;            	//  ABCDEF
  y--;                          	//    
  t--;                          	//   
  a/=m;                         	//  
  }while(a&&t);                 	//    
if(m!=10)while(t--)*y--='0';    	//     
else while(t--)*y--=' ';        	//    
}
//------------------------------------------------------------------------------
// f -  
// t -     
// z -    
void PrnFlo(float f, BYTE t, BYTE z)
{
BYTE *y=(BYTE*)(WORD(V2)+(xSh+=t-1));//     
xSh++;								//       
bool s;                         	//  
if(f<0){f=-f; s=1;}else s=0;    	//  f       
for(BYTE i=0; i<z; i++)f*=10;   	//   
WORD ff=f;                      	// 
do{                             	//         
  *y--=(ff%10)+'0';             	//  
  ff/=10;                       	//  
  t--;                          	//   
  if(!(--z)){*y--='.'; t--;}    	//        
  if(z&128 && !ff)break;        	//   1        
  }while(t);                    	//    
if(s&&t){*y--='-'; t--;}        	//     
while(t--)*y--=' ';             	//       float
}        
//------------------------------------------------------------------------------

//******************************************************************************
// 
//******************************************************************************

//------------------------------------------------------------------------------
//    
//      74HC595D
//      (s_1DS  s_2DS), 
//   (s_CLK)   (s_RCLK)    ,
//       .
//
//        
//          
//      , ..  
//   .
void SetBalansir(void)
{
BYTE x=128;
for(BYTE z=0; z<8; z++)
  {
  s_1DS=bool(BAL1&x);
  s_2DS=bool(BAL2&x);
  s_CLK=1;
  s_CLK=0;
  x>>=1;
  }
s_RCLK=1;
s_RCLK=0;
}
//------------------------------------------------------------------------------ 

//******************************************************************************
//  
//******************************************************************************

//     
// n -  
// h=(0-BYTE 1-WORD 2-LONG 3-FLOAT 255-1 254-0)
void *GetKK(BYTE n, BYTE &h)
{
h=0;
switch(n)
  {
  case 0:  h=2; return((void*)(&Secs));         //    
  case 1:  h=0; return((void*)(&Stroka));       //  
  case 2:  h=3; return((void*)(&F));       //  
  default: h=0; return(0);
  }
} 
//******************************************************************************
